#include <allegro.h>
#include <stdio.h>
#include <iostream>
#include "4Gewinnt.h"

#define SIZE 80
#define MOUSE_DOWN 0
#define MOUSE_UP 1

int gameover = 0;

int Proof(_4Gewinnt* game);

char* text[2] = {"Blau gewinnt!", "Rot gewinnt!"};

int main() 
{	
	allegro_init();
	install_keyboard();
	install_mouse();
	
	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, SIZE*FIELD_W, SIZE*FIELD_H, 0, 0);
	
	BITMAP* TScreen = create_bitmap(SCREEN_W,SCREEN_H);
	BITMAP* buffer = create_bitmap(SCREEN_W,SCREEN_H);
	BITMAP* temp = create_bitmap(SCREEN_W,SCREEN_H);
	clear_to_color(temp, makecol(255,255,255));
	
    _4Gewinnt* game = new _4Gewinnt();
    int mouse = MOUSE_UP;
	int last = 0;
	while(!key[KEY_ESC])
	{
        //Draw Gamefield 
        clear(buffer);
        for(int i = 0; i < FIELD_W;i++)
            rect(buffer,i*SIZE,0,i*SIZE+SIZE-1,SCREEN_H-1,makecol(255,255,255)); 
        for(int i = 0; i < FIELD_H;i++)
            rect(buffer,0,i*SIZE,SCREEN_W-1,i*SIZE+SIZE-1,makecol(255,255,255));
        
        //Draw pieces
        for(int x = 0; x < FIELD_W; x++)
            for(int y = 0; y < FIELD_H; y++)        
                if(game->field[x][y] != 0)
                    circlefill(buffer, x * SIZE + (int)(SIZE*0.5), SCREEN_H - y * SIZE - (int)(SIZE*0.5),(int)(SIZE*0.4), game->field[x][y] == 1 ? makecol(255,0,0):makecol(0,0,255));
        if(gameover)
        {     
            set_trans_blender(0,0,0, 200);
            draw_trans_sprite(buffer, temp, 0,0);
            textout_ex(buffer, font, text[(gameover + 1) / 2], SCREEN_W / 2, SCREEN_H / 2, gameover == 1 ? makecol(255,0,0) : makecol(0,0,255), -1);
        }
        circlefill(buffer,mouse_x,mouse_y,SIZE / 5, game->player == 1 ? makecol(255,0,0):makecol(0,0,255));
        draw_sprite(screen, buffer, 0,0);
        
        if(mouse_b & 0x01)
        {
            mouse = MOUSE_DOWN;
        }
        if(!mouse_b && mouse == MOUSE_DOWN)
        {
            mouse = MOUSE_UP;
            if(gameover)
            {
                gameover = 0;
                game->Clear();
            }
            else
                if(game->Move(last = mouse_x / SIZE) != -1)
                {   
                    printf("Bewertung: %d\n", Proof(game));
                    if(!gameover)
                    {
                        game->DoMove();
                        printf("Bewertung: %d\n", Proof(game));
                    }
                }
        } 
        if(key[KEY_SPACE] && !gameover) //Rckgngigfunktion nur zu DEBUG - Zwecken
        {
            while(key[KEY_SPACE]);
            game->Undo(last);  
        }
        rest(5);           //5ms warten
    }
    //Objekte lschen
	delete game; 
	destroy_bitmap(buffer);
	destroy_bitmap(temp);
	destroy_bitmap(TScreen);
	return 0;
}
END_OF_MAIN();

int Proof(_4Gewinnt* game)
{
    int i = game->Rate();
    if(1000 == ABS(i))
    {
        gameover = SGN(i);
    }
    return i;
}
